import express, {type Router} from "express";
import UserGuard from "@validators/UserGuard";
import AdminGuard from "@validators/AdminGuard";
import AuthController from "@controllers/AuthController";


const router: Router = express.Router();

router.route('/login').post(AuthController.login)
router.route('/register').post(AuthController.register)

// PATCH
//TODO - To test
router.route('/me')
	.patch(UserGuard, AuthController.editUser)

// GET
router.route('/me')
	.get(UserGuard, AuthController.getSelf)

// DELETE
router.route('/me')
	.delete(UserGuard, AuthController.deleteSelf)


// GET
router.route('/all')
	.get(AdminGuard, AuthController.getAllUsers)


// GET
router.route('/user/:targetId')
	.get(AdminGuard, AuthController.getUser)
	.patch(AdminGuard, AuthController.editUser)
	.delete(AdminGuard, AuthController.deleteUser)


export default router